<?php
/*
 * @package Wg Extra Tabs
 * @version 1.0
 * @license http://creativecommons.org/licenses/by-nc/4.0/ licencia de Creative Commons Reconocimiento-NoComercial 4.0 Internacional
 * @Website: http://www.wegocio.com
*/

if (!defined('_PS_VERSION_'))
	exit;

class WgExtraTabsClass extends ObjectModel{
	public $id;

	public $id_shop;
	public $id_category;
	public $id_product;
	public $content;
	public $title;
    
	/**
	 * @see ObjectModel::$definition
	 */
	public static $definition = array(
		'table'   => 'wg_extra_tabs',
		'primary' => 'id_wg_extra_tabs',
		'multilang' => true,
		'fields' => array(
      'id_shop'         => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedId', 'required' => true),
			'id_category'     => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedInt'),
			'id_product'      => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedInt'),
			'content'         => array('type' => self::TYPE_HTML, 'lang' => true, 'validate' => 'isAnything'),
			'title'           => array('type' => self::TYPE_STRING, 'lang' => true, 'validate' => 'isGenericName', 'size' => 255),
		)
	);
  
  public static function getLastId(){
    return Db::getInstance()->getValue('
      SELECT ret.`id_wg_extra_tabs`
      FROM `'._DB_PREFIX_.'wg_extra_tabs` ret
      ORDER BY id_wg_extra_tabs DESC'
      );
  }
  public static function getTabs($field,$id_product,$id_lang){
    $categories = array();
    $context = Context::getContext();
      
    $where ='';
    
    if($id_product)
      $where .= 'ret.`id_product`='.(int)$id_product;
           
    
    return Db::getInstance()->executeS('
      SELECT ret.`id_wg_extra_tabs`,'.$field.'
      FROM `'._DB_PREFIX_.'wg_extra_tabs` ret
      LEFT JOIN `'._DB_PREFIX_.'wg_extra_tabs_lang` retl ON (ret.`id_wg_extra_tabs` = retl.`id_wg_extra_tabs`)
      WHERE ('.$where.') AND retl.`id_lang` = '.(int)$id_lang.' '.Shop::addSqlRestrictionOnLang('ret')
      );
  }
  
  public static function getTabsBySpecificID($field,$id_product){     
    return Db::getInstance()->executeS('
			SELECT ret.`id_wg_extra_tabs`,'.$field.'
			FROM `'._DB_PREFIX_.'wg_extra_tabs` ret
			LEFT JOIN `'._DB_PREFIX_.'wg_extra_tabs_lang` retl ON (ret.`id_wg_extra_tabs` = retl.`id_wg_extra_tabs`)
			WHERE ret.`id_product`='.(int)$id_product.Shop::addSqlRestrictionOnLang('ret')
		);
  }

  public static function getIdBySpecific($id_product){
    if(!$id_product)
      return false;
    return Db::getInstance()->executeS('
			SELECT ret.`id_wg_extra_tabs`
			FROM `'._DB_PREFIX_.'wg_extra_tabs` ret
			WHERE ret.`id_product`='.(int)$id_product.Shop::addSqlRestrictionOnLang('ret')
		);
  }
  
  public static function deleteByProductId($id_product){
    if(!$id_product)
      return false;
    $ret = true;
    $tabs = Db::getInstance()->executeS('
      SELECT `id_wg_extra_tabs` 
      FROM `'._DB_PREFIX_.'wg_extra_tabs` 
      WHERE `id_product` ='.(int)$id_product
    );
    foreach($tabs AS $tab){
      $model = new WgExtraTabsClass((int)$tab['id_wg_extra_tabs']);
      if ($model->id)
          $ret &= $model->delete();
    }
      
    return $ret;
  }
  
  public static function deleteByTabId($id_tab){
    if(!$id_tab)
      return false;
    $ret = true;
    $tabs = Db::getInstance()->executeS('
      SELECT `id_wg_extra_tabs` 
      FROM `'._DB_PREFIX_.'wg_extra_tabs` 
      WHERE `id_wg_extra_tabs` ='.(int)$id_tab
    );
    foreach($tabs AS $tab){
      $model = new WgExtraTabsClass((int)$tab['id_wg_extra_tabs']);
      if ($model->id)
          $ret &= $model->delete();
    }
      
    return $ret;
  }
  public static function deleteByCategoryId($id_category){
    if(!$id_category)
        return false;
    $ret = true;
    $tabs = Db::getInstance()->executeS('
        SELECT `id_wg_extra_tabs` 
        FROM `'._DB_PREFIX_.'wg_extra_tabs` 
        WHERE `id_category` ='.(int)$id_category
    );
    foreach($tabs AS $tab){
      $model = new WgExtraTabsClass((int)$tab['id_wg_extra_tabs']);
      if ($model->id)
          $ret &= $model->delete();
    }
        
    return $ret;
  }
	public function copyFromPost(){
		/* Classical fields */
		foreach ($_POST AS $key => $value)
			if (key_exists($key, $this) AND $key != 'id_'.$this->table)
				$this->{$key} = $value;

		/* Multilingual fields */
		if (sizeof($this->fieldsValidateLang)){
			$languages = Language::getLanguages(false);
			foreach ($languages AS $language)
				foreach ($this->fieldsValidateLang AS $field => $validation)
					if (isset($_POST[$field.'_'.(int)($language['id_lang'])]))
						$this->{$field}[(int)($language['id_lang'])] = $_POST[$field.'_'.(int)($language['id_lang'])];
		}
	}
}