{*
 * @package Wg Extra Tabs
 * @version 1.0
 * @license http://creativecommons.org/licenses/by-nc/4.0/ licencia de Creative Commons Reconocimiento-NoComercial 4.0 Internacional
 * @Website: http://www.wegocio.com
*}

<div id="wgextratabs" class="panel product-tab">
  <h3>{l s='Extra Tabs' mod='wgextratabs'} <a href="http://www.wegocio.com">[WEGOCIO]</a></h3>
  {include file="controllers/products/multishop/check_fields.tpl" product_tab="ModuleWgextratabs"}
  <table class="table">
    <thead>
      <tr>
        <th class="col-lg-4">
        {include file="controllers/products/multishop/checkbox.tpl" field="extratabs_title" type="default" multilang="true"}
        <span class="title_box">{l s='Title:' mod='wgextratabs'}</span></th>
        <th class="col-lg-8"><span class="title_box">{l s='Content:' mod='wgextratabs'}</span></th>
      </tr>
    </thead>
    <tbody>
      {foreach $tabs as $tab}
        <tr class="tab wgextratab" id="wgextraTab{$tab['id']}">
          <td class="title wgextratab"  style="vertical-align:top">           
            <div class="col-lg-12">
              {include file="controllers/products/input_text_lang.tpl"
                languages=$languages
                input_name="{$tab['id']}_extratabs_title"
                input_value=$tab['title']
              }
            </div>
          </td>
          <td class="content wgextratab" style="vertical-align:top">       
              <div class="col-lg-12">
                {include
                  file="controllers/products/textarea_lang.tpl"
                  languages=$languages
                  input_name="{$tab['id']}_extratabs_content"
                  class="extratabs_autoload_rte"
                  input_value=$tab['content']
                }
              </div>
          </td>
        </tr>
        
        <script type="text/javascript">          
          hideOtherLanguage({$default_form_language});
        </script>
        
      {/foreach}
      <input type="hidden" id="new-tabs-id"  name="new-tabs-id" value=""/>
    </tbody>
  </table>
  <a href="#" id="add-new-tab" class="btn btn-link button">
		<i class="icon-plus-sign"></i> {l s='Add a new tab' mod='wgextratabs'}
	</a>
  
  <script type="text/javascript">      
    $('#add-new-tab').click(function(){
      var actualId = $( "#wgextratabs .table tbody tr" ).last().attr('id');
      
      if(actualId === undefined )
        var id = parseInt(1);
      else
        var id = parseInt((actualId).substring(10))+1;
        
      var html ='<tr class="tab wgextratab" id="wgextraTab'+id+'">'+
                  '<td class="title wgextratab" style="vertical-align:top">';
            $.each(languages, function(k, v){
              html +='<div class="translatable-field row lang-'+v.id_lang+'">'+
                      '<div class="col-lg-9">'+
                        '<input type="text" id="'+id+'_extratabs_title_'+v.id_lang+'" placeholder="{l s='Enter your title here' mod='wgextratabs'}" class="form-control" name="'+id+'_extratabs_title_'+v.id_lang+'" value="" onkeyup="if (isArrowKey(event)) return ;updateFriendlyURL();" onblur="updateLinkRewrite();"/>'+
                      '</div>'+
                      '<div class="col-lg-2">'+
                        '<button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown" tabindex="-1">'+v.iso_code+'<span class="caret"></span></button>'+
                        '<ul class="dropdown-menu">';
                          $.each(languages, function(k2, v2){
                            html +='<li><a href="javascript:tabs_manager.allow_hide_other_languages = false;hideOtherLanguage('+v2.id_lang+');">'+v2.name+'</a></li>';
                          })
              html +=   '</ul>'+
                      '</div>'+
                    '</div>';
            }); 
          html += '</td>'+
                  '<td class="content wgextratab" style="vertical-align:top">';
          $.each(languages, function(k, v){
            html +='<div class="translatable-field row lang-'+v.id_lang+'" style="display: block;">'+
                    '<div class="col-lg-9">'+
                      '<textarea id="'+id+'_extratabs_content_'+v.id_lang+'" name="'+id+'_extratabs_content_'+v.id_lang+'" placeholder="{l s='Enter your content here' mod='wgextratabs'}" class="textarea-autosize"></textarea>'+
                      '<span class="counter" data-max="none"></span>'+
                    '</div>'+
                    '<div class="col-lg-2">'+
                      '<button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown">'+v.iso_code+'<span class="caret"></span></button>'+
                      '<ul class="dropdown-menu">';
                        $.each(languages, function(k2, v2){
                          html +='<li><a href="javascript:tabs_manager.allow_hide_other_languages = false;hideOtherLanguage('+v2.id_lang+');">'+v2.name+'</a></li>';
                        })
           html +=    '</ul>'+
                    '</div>'+
                  '</div>';
            })
          html +='</td>'+
               '</tr>';

        
      $('#wgextratabs .table tbody').append(html);
      
      hideOtherLanguage({$default_form_language});
      if( $('#new-tabs-id').val() != "" )
        $('#new-tabs-id').val($('#new-tabs-id').val()+','+id);
      else 
        $('#new-tabs-id').val(id);
    });
  </script>
  
  <div class="panel-footer">
    <a href="{$link->getAdminLink('AdminProducts')}" class="btn btn-default"><i class="process-icon-cancel"></i> {l s='Cancel'}</a>
    <button type="submit" name="submitAddproduct" class="btn btn-default pull-right"><i class="process-icon-save"></i> {l s='Save'}</button>
    <button type="submit" name="submitAddproductAndStay" class="btn btn-default pull-right"><i class="process-icon-save"></i> {l s='Save and stay'}</button>
  </div>
</div>
<script type="text/javascript">
  if(!display_multishop_checkboxes) {
      ad = '{$ad}';
      iso = '{$iso_tiny_mce}';
    }
  hideOtherLanguage({$default_form_language});
</script>
{block name="autoload_tinyMCE"}
<script type="text/javascript">
  {literal}
   tabs_manager.onLoad("ModuleWgextratabs", function(){
      tinySetup({
    editor_selector :"extratabs_autoload_rte"
  });
  });    
  {/literal}
</script>
{/block}
<script type="text/javascript">
  {literal}
  $(document).ready(function($){ 

      ProductMultishop.checkAllModuleWgextratabs = function()
      {
           $.each(languages, function(k, v)
            {
              ProductMultishop.checkField($('input[name=\'multishop_check[extratabs_title]['+v.id_lang+']\']').prop('checked'), 'extratabs_title_'+v.id_lang);
              ProductMultishop.checkField($('input[name=\'multishop_check[extratabs_content]['+v.id_lang+']\']').prop('checked'), 'extratabs_content_'+v.id_lang, 'tinymce');
            });
          ProductMultishop.checkField($('input[name=\'multishop_check[extratabs_active]\']').prop('checked'), 'extratabs_active');   
      }

    if(display_multishop_checkboxes)
      {
          ProductMultishop.checkAllModuleWgextratabs();
      }
  });
  {/literal}
</script>
