<?php
/*
 * @package Wg Extra Tabs
 * @version 1.0
 * @license http://creativecommons.org/licenses/by-nc/4.0/ licencia de Creative Commons Reconocimiento-NoComercial 4.0 Internacional
 * @Website: http://www.wegocio.com
*/

if (!defined('_PS_VERSION_'))
	exit;

include_once(dirname(__FILE__).'/WgExtraTabsClass.php');

class WgExtraTabs extends Module{
  const INSTALL_SQL_FILE = 'install.sql';
	private $_html = '';
  public  $fields_list;
  public  $fields_value;
  public  $fields_form;
	private $spacer_size = '5';

	public function __construct(){
		$this->name          = 'wgextratabs';
		$this->tab           = 'front_office_features';
		$this->version       = '1.0.0';
		$this->author        = 'WEGOCIO.COM';
		$this->need_instance = 0;
		$this->bootstrap 	 = true;
		parent::__construct();

		$this->displayName   = $this->l('Product Extra Tabs');
		$this->description   = $this->l('With this module you can add to the wished products any number of custom tabs.');
	}

	public function install(){
	  if (!file_exists(dirname(__FILE__).'/'.self::INSTALL_SQL_FILE))
			return false;
		else if (!$sql = file_get_contents(dirname(__FILE__).'/'.self::INSTALL_SQL_FILE))
			return false;

		$sql = str_replace(array('PREFIX_', 'ENGINE_TYPE'), array(_DB_PREFIX_, _MYSQL_ENGINE_), $sql);
		$sql = preg_split("/;\s*[\r\n]+/", trim($sql));

		foreach ($sql as $query)
			if (!Db::getInstance()->execute(trim($query)))
				return false;   
        
      $res = parent::install() &&
			$this->registerHook('productTab')  &&
			$this->registerHook('productTabContent')  &&
			$this->registerHook('displayAdminProductsExtra')  &&
			$this->registerHook('actionProductUpdate')  &&
			$this->registerHook('actionProductAdd')  &&
			$this->registerHook('actionProductDelete')&&
			$this->registerHook('ActionCategoryDelete');
        
    return $res;
	}

  public function uninstall(){
    if (!parent::uninstall() || 
        !$this->deleteTables()
        )
      return false;
    return true;
  }

  private function deleteTables(){
    return Db::getInstance()->execute('
      DROP TABLE IF EXISTS
      `'._DB_PREFIX_.'wg_extra_tabs`,
      `'._DB_PREFIX_.'wg_extra_tabs_lang`');
  }
  
  public function hookProductTab($params){
    if (!$id_product = (int)Tools::getValue('id_product'))
      return false;
    
    $product = new Product($id_product);
    $id_category = $product->id_category_default;
        
    $tabsHeader = WgExtraTabsClass::getTabs('title',$id_product,$this->context->language->id);
    //$tabsHeader=WgExtraTabsClass::getTabsBySpecificID('id_lang,title',$id_product);
        
    $this->smarty->assign(array(
      'tabsHeader' => $tabsHeader,
    ));
    return ($this->display(__FILE__, 'tab.tpl'));
  }
  
  public function hookProductTabContent($params){
    if (!$id_product = (int)Tools::getValue('id_product'))
      return false;
      
    $product = new Product($id_product);
    $id_category = $product->id_category_default;
      
    $tabsContent = WgExtraTabsClass::getTabs('title,content',$id_product,$this->context->language->id);
    //$tabsContent=WgExtraTabsClass::getTabsBySpecificID('id_lang,title,content',$id_product);
      
    $this->smarty->assign(array(
      'tabsContent' => $tabsContent,
    ));
    return ($this->display(__FILE__, 'wgextratabs.tpl'));
  }
  
  public function hookDisplayAdminProductsExtra($params){   
    $iso_tiny_mce = $this->context->language->iso_code;
    $iso_tiny_mce = (file_exists(_PS_JS_DIR_.'tiny_mce/langs/'.$iso_tiny_mce.'.js') ? $iso_tiny_mce : 'en');
    
    $tabs=WgExtraTabsClass::getTabsBySpecificID('id_lang,title,content',(int)Tools::getValue('id_product'));
    foreach ($tabs as $tab){
      $tabsFinal[$tab['id_wg_extra_tabs']]['title'][$tab['id_lang']]=$tab['title'];
      $tabsFinal[$tab['id_wg_extra_tabs']]['content'][$tab['id_lang']]=$tab['content'];
      $tabsFinal[$tab['id_wg_extra_tabs']]['id']=$tab['id_wg_extra_tabs'];
    }
 
    $this->smarty->assign(array(
      'tabs' => $tabsFinal,
      'languages' => $this->getLanguages(),
      'default_form_language'=> $this->context->controller->default_form_language,
    ));
    
    return $this->display(__FILE__, 'views/templates/admin/wgextratabs.tpl');
  }
   
  public function getLanguages(){
    $cookie = $this->context->cookie;
    $allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;

    if ($allow_employee_form_lang && !$cookie->employee_form_lang)
      $cookie->employee_form_lang = (int)Configuration::get('PS_LANG_DEFAULT');

    $use_lang_from_cookie = false;
    $languages = Language::getLanguages(false);

    if ($allow_employee_form_lang)
      foreach ($languages as $lang)
        if ($cookie->employee_form_lang == $lang['id_lang'])
          $use_lang_from_cookie = true;

    if (!$use_lang_from_cookie)
      $default_form_language = (int)Configuration::get('PS_LANG_DEFAULT');
    else
      $default_form_language = (int)$cookie->employee_form_lang;

    foreach ($languages as $k => $language)
      $languages[$k]['is_default'] = (int)($language['id_lang'] == $default_form_language);

    return $languages;
  }
  
  public function hookActionProductUpdate($params){
    $id_lang = (int)Configuration::get('PS_LANG_DEFAULT');
    $languages = Language::getLanguages(false);
    
    $id_product = (int) $params['id_product'];
    $product = new Product($id_product);
    $id_category = $product->id_category_default;
    $id_shop = (int)$this->context->shop->id;
    
    $newTabsIdArray = explode(',',Tools::getValue('new-tabs-id'));
    
    $oldTabsIdObjectsArray = WgExtraTabsClass::getIdBySpecific($id_product);
    foreach($oldTabsIdObjectsArray as $oldTabIdObjectArray)
      $oldTabsIdArray[] = (int)$oldTabIdObjectArray['id_wg_extra_tabs'];
    
    if($newTabsIdArray[0]){
      foreach($newTabsIdArray as $newTabId){
        $extratabs = new WgExtraTabsClass();
      
        $extratabs->id_product = $id_product;
        $extratabs->id_category = $id_category;
        $extratabs->id_shop = $id_shop;
        
        $is_blank_lang = true;
        
        foreach ($languages as $lang){
          if (!empty($_POST[$newTabId.'_extratabs_title_'.$lang['id_lang']]))
            $extratabs->title[(int)$lang['id_lang']] = Tools::getValue($newTabId.'_extratabs_title_'.(int)$lang['id_lang']);
          else
            $extratabs->title[(int)$lang['id_lang']] = Tools::getValue($newTabId.'_extratabs_title_'.$id_lang);
                
          if (!empty($_POST[$newTabId.'_extratabs_content_'.$lang['id_lang']]))
            $extratabs->content[(int)$lang['id_lang']] = Tools::getValue($newTabId.'_extratabs_content_'.(int)$lang['id_lang']);
          else
            $extratabs->content[(int)$lang['id_lang']] = Tools::getValue($newTabId.'_extratabs_content_'.$id_lang);
          
          $is_blank_lang &= empty($extratabs->title[(int)$lang['id_lang']]) && empty($extratabs->content[(int)$lang['id_lang']]);
        }
        
        if (!$is_blank_lang)
          $extratabs->save();
        
        unset($extratabs);
      }
    }
    
    if($oldTabsIdArray){
      foreach($oldTabsIdArray as $oldTabId){
        $extratabs = new WgExtraTabsClass($oldTabId);
      
        $extratabs->id_product = $id_product;
        $extratabs->id_category = $id_category;
        $extratabs->id_shop = $id_shop;
        
        $is_blank_lang = true;
        
        foreach ($languages as $lang){
          if (!empty($_POST[$extratabs->id.'_extratabs_title_'.$lang['id_lang']]))
            $extratabs->title[(int)$lang['id_lang']] = Tools::getValue($extratabs->id.'_extratabs_title_'.(int)$lang['id_lang']);
          else
            $extratabs->title[(int)$lang['id_lang']] = Tools::getValue($extratabs->id.'_extratabs_title_'.$id_lang);
                
          if (!empty($_POST[$extratabs->id.'_extratabs_content_'.$lang['id_lang']]))
            $extratabs->content[(int)$lang['id_lang']] = Tools::getValue($extratabs->id.'_extratabs_content_'.(int)$lang['id_lang']);
          else
            $extratabs->content[(int)$lang['id_lang']] = Tools::getValue($extratabs->id.'_extratabs_content_'.$id_lang);
          
          $is_blank_lang &= empty($extratabs->title[(int)$lang['id_lang']]) && empty($extratabs->content[(int)$lang['id_lang']]);
        }

        if ($is_blank_lang)
            $extratabs->delete();
         else 
           $extratabs->save();
        
        unset($extratabs);
      }
    }
    
    return ;
  }
  
  public function hookActionProductAdd($params){
    
    
    return $this->hookActionProductUpdate($params);
  }
  
  public function hookActionProductDelete($params){
    $res = true;
    $id_wg_extra_tabs = WgExtraTabsClass::getIdBySpecific($params['product']->id);
    
    foreach($id_wg_extra_tabs as $id){
      $extratabs = new WgExtraTabsClass((int)$id['id_wg_extra_tabs']);
      if ($extratabs->id)
        $res &= $extratabs->delete();
    }
    
    $res &= WgExtraTabsClass::deleteByProductId($params['product']->id);

    return ;
  }
  
  public function hookActionCategoryDelete($params){
    if(!$params['category']->id)
        return ;
    return WgExtraTabsClass::deleteByCategoryId($params['category']->id);
  }
  
}